#property copyright "Dmitry Yakovlev, Russia,Omsk WM R865705290089"
#property link      "http://fehu.b13.su/  dmitryyakv@yandex.ru  ICQ: 11-065-106"

#property indicator_chart_window
#property indicator_buffers 1
//---- indicator parameters
extern int     ExtDepth=3;
extern int     ExtDeviation=5;
extern int     ExtBackstep=3;
extern bool    Distance=true;
extern int     cnt_draw=5;
extern color   FiboColor=Blue;
extern color   ZZColor=Tomato;
extern int     ZZWidth=2;
extern int     DrawMode=0;
//---- indicator buffers
double ZigzagBuffer[];
double HighMapBuffer[];
double LowMapBuffer[];
int level=3; // recounting's depth 
bool downloadhistory=false;

int OldLastZigZag, OldPreviousZigZag;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(3);
//---- drawing settings
//---- indicator buffers mapping
   SetIndexBuffer(0,ZigzagBuffer); SetIndexStyle(0,DRAW_SECTION,0,ZZWidth,ZZColor);
   SetIndexBuffer(1,HighMapBuffer);
   SetIndexBuffer(2,LowMapBuffer);
   SetIndexEmptyValue(0,0.0);
//---- indicator short name
   IndicatorShortName("ZZFibo");
//---- initialization done
   return(0);
 }
  
int deinit() 
{
	delete_all();
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   int i, counted_bars = IndicatorCounted();
   int limit,counterZ,whatlookfor;
   int shift,back,lasthighpos,lastlowpos;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;

   if (counted_bars==0 && downloadhistory) // history was downloaded
     {
      ArrayInitialize(ZigzagBuffer,0.0);
      ArrayInitialize(HighMapBuffer,0.0);
      ArrayInitialize(LowMapBuffer,0.0);
     }
   if (counted_bars==0) 
     {
      limit=Bars-ExtDepth;
      downloadhistory=true;
     }
   if (counted_bars>0) 
     {
      while (counterZ<level && i<100)
        {
         res=ZigzagBuffer[i];
         if (res!=0) counterZ++;
         i++;
        }
      i--;
      limit=i;
      if (LowMapBuffer[i]!=0) 
        {
         curlow=LowMapBuffer[i];
         whatlookfor=1;
        }
      else
        {
         curhigh=HighMapBuffer[i];
         whatlookfor=-1;
        }
      for (i=limit-1;i>=0;i--)  
        {
         ZigzagBuffer[i]=0.0;  
         LowMapBuffer[i]=0.0;
         HighMapBuffer[i]=0.0;
        }
     }
      
   for(shift=limit; shift>=0; shift--)
     {
      val=Low[iLowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=LowMapBuffer[shift+back];
               if((res!=0)&&(res>val)) LowMapBuffer[shift+back]=0.0; 
              }
           }
        } 
      if (Low[shift]==val) LowMapBuffer[shift]=val; else LowMapBuffer[shift]=0.0;
      //--- high
      val=High[iHighest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=HighMapBuffer[shift+back];
               if((res!=0)&&(res<val)) HighMapBuffer[shift+back]=0.0; 
              } 
           }
        }
      if (High[shift]==val) HighMapBuffer[shift]=val; else HighMapBuffer[shift]=0.0;
     }

   // final cutting 
   if (whatlookfor==0)
     {
      lastlow=0;
      lasthigh=0;  
     }
   else
     {
      lastlow=curlow;
      lasthigh=curhigh;
     }
   for (shift=limit;shift>=0;shift--)
     {
      res=0.0;
      switch(whatlookfor)
        {
         case 0: // look for peak or lawn 
            if (lastlow==0 && lasthigh==0)
              {
               if (HighMapBuffer[shift]!=0)
                 {
                  lasthigh=High[shift];
                  lasthighpos=shift;
                  whatlookfor=-1;
                  ZigzagBuffer[shift]=lasthigh;
                  res=1;
                 }
               if (LowMapBuffer[shift]!=0)
                 {
                  lastlow=Low[shift];
                  lastlowpos=shift;
                  whatlookfor=1;
                  ZigzagBuffer[shift]=lastlow;
                  res=1;
                 }
              }
             break;  
         case 1: // look for peak
            if (LowMapBuffer[shift]!=0.0 && LowMapBuffer[shift]<lastlow && HighMapBuffer[shift]==0.0)
              {
               ZigzagBuffer[lastlowpos]=0.0;
               lastlowpos=shift;
               lastlow=LowMapBuffer[shift];
               ZigzagBuffer[shift]=lastlow;
               res=1;
              }
            if (HighMapBuffer[shift]!=0.0 && LowMapBuffer[shift]==0.0)
              {
               lasthigh=HighMapBuffer[shift];
               lasthighpos=shift;
               ZigzagBuffer[shift]=lasthigh;
               whatlookfor=-1;
               res=1;
              }   
            break;               
         case -1: // look for lawn
            if (HighMapBuffer[shift]!=0.0 && HighMapBuffer[shift]>lasthigh && LowMapBuffer[shift]==0.0)
              {
               ZigzagBuffer[lasthighpos]=0.0;
               lasthighpos=shift;
               lasthigh=HighMapBuffer[shift];
               ZigzagBuffer[shift]=lasthigh;
              }
            if (LowMapBuffer[shift]!=0.0 && HighMapBuffer[shift]==0.0)
              {
               lastlow=LowMapBuffer[shift];
               lastlowpos=shift;
               ZigzagBuffer[shift]=lastlow;
               whatlookfor=1;
              }   
            break;               
         default: return; 
        }
     }
   //=====================================================================
   ///<--- fibo  
 	int st=0;
  	if(DrawMode==0) st=1; else st=0;
  	i=0;
  	int LastZigZag, PreviousZigZag;
   double razn=0;
   double shift2=0;
   int h=st;
   while(ZigzagBuffer[h]==0) h++;
   LastZigZag=h;
   h++;
   while(ZigzagBuffer[h]==0) h++;
   PreviousZigZag=h;
   //------------------------------------------------------
   if (OldLastZigZag!=LastZigZag || OldPreviousZigZag!=PreviousZigZag)
   {
      delete_all();
      
   	OldLastZigZag=LastZigZag;
   	OldPreviousZigZag=PreviousZigZag;
   	i=0;
   	for(i=0;i<cnt_draw;i++)
   	{
         ObjectCreate("Fibo"+i, OBJ_FIBO, 0, Time[LastZigZag], ZigzagBuffer[PreviousZigZag], Time[LastZigZag], ZigzagBuffer[LastZigZag]);
   	    
         if(i!=0) ObjectSet("Fibo"+i, OBJPROP_RAY, false);
         else ObjectSet("Fibo"+i, OBJPROP_RAY, true);
         ObjectSet("Fibo"+i, OBJPROP_LEVELCOLOR, FiboColor);
         ObjectSet("Fibo"+i, OBJPROP_LEVELWIDTH, 2);
         ObjectSet("Fibo"+i, OBJPROP_FIBOLEVELS, 6);
         ObjectSet("Fibo"+i, OBJPROP_FIRSTLEVEL+0, 0.000); ObjectSetFiboDescription("Fibo"+i,0,"0%");
         ObjectSet("Fibo"+i, OBJPROP_FIRSTLEVEL+1, 0.236); ObjectSetFiboDescription("Fibo"+i,1,"23.6%");
         ObjectSet("Fibo"+i, OBJPROP_FIRSTLEVEL+2, 0.500); ObjectSetFiboDescription("Fibo"+i,2,"50%");
         ObjectSet("Fibo"+i, OBJPROP_FIRSTLEVEL+3, 0.764); ObjectSetFiboDescription("Fibo"+i,3,"76.4%");
         ObjectSet("Fibo"+i, OBJPROP_FIRSTLEVEL+4, 1.000); ObjectSetFiboDescription("Fibo"+i,4,"100%");
         ObjectSet("Fibo"+i, OBJPROP_FIRSTLEVEL+5, -0.500); ObjectSetFiboDescription("Fibo"+i,5,"-50%");
         //------------------------------------------------------
         if(Distance)
         {
           razn=MathAbs((ZigzagBuffer[PreviousZigZag]-ZigzagBuffer[LastZigZag])/Point);
           shift2=0;
           if(ZigzagBuffer[PreviousZigZag]>ZigzagBuffer[LastZigZag]) shift2=0;
           else shift2=(WindowPriceMax()-WindowPriceMin())/20;
      
	        ObjectCreate("ZigZagFiboRazn"+i, OBJ_TEXT, 0, Time[LastZigZag], ZigzagBuffer[LastZigZag]+shift2);
           ObjectSetText("ZigZagFiboRazn"+i, DoubleToStr(razn,0), 9, "Arial", FiboColor);
         }
         LastZigZag=PreviousZigZag;
         h++;
         while(ZigzagBuffer[h]==0) h++;
         PreviousZigZag=h;
      }
   	//PlaySound("alert.wav");
   }
   //------------------------------------------------------
}
  
void delete_all()
{
	int i;
	for(i=0;i<cnt_draw;i++)
	{
	  ObjectDelete("Fibo"+i);
	  ObjectDelete("ZigZagFiboRazn"+i);
	}
}


